Index: sched.c
===================================================================
--- sched.c	(revision 9835)
+++ sched.c	(revision 9836)
@@ -64,6 +64,8 @@
 	AST_LIST_HEAD_NOLOCK(, sched) schedc;   /*!< Cache of unused schedule structures and how many */
 	unsigned int schedccnt;
 #endif
+
+	int callback_is_called;
 };
 
 struct sched_context *sched_context_create(void)
@@ -272,6 +274,13 @@
 	DEBUG(ast_debug(1, "ast_sched_del()\n"));
 	
 	ast_mutex_lock(&con->lock);
+	/* don't exit this function until callback is run to the end */
+	while (con->callback_is_called) {
+		ast_mutex_unlock(&con->lock);
+		usleep(10);
+		ast_mutex_lock(&con->lock);
+	}	
+	
 	AST_LIST_TRAVERSE_SAFE_BEGIN(&con->schedq, s, list) {
 		if (s->id == id) {
 			AST_LIST_REMOVE_CURRENT(list);
@@ -365,9 +374,11 @@
 		 * should return 0.
 		 */
 			
+		con->callback_is_called = 1;	
 		ast_mutex_unlock(&con->lock);
 		res = current->callback(current->data);
 		ast_mutex_lock(&con->lock);
+		con->callback_is_called = 0;	
 			
 		if (res) {
 		 	/*
